<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfParcelStatus ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfParcelStatus
 * @subpackage Arrays
 */
class ArrayOfParcelStatus extends AbstractStructArrayBase
{
    /**
     * The ParcelStatus
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ParcelStatus[]
     */
    public $ParcelStatus;
    /**
     * Constructor method for ArrayOfParcelStatus
     * @uses ArrayOfParcelStatus::setParcelStatus()
     * @param \StructType\ParcelStatus[] $parcelStatus
     */
    public function __construct(array $parcelStatus = array())
    {
        $this
            ->setParcelStatus($parcelStatus);
    }
    /**
     * Get ParcelStatus value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ParcelStatus[]|null
     */
    public function getParcelStatus()
    {
        return isset($this->ParcelStatus) ? $this->ParcelStatus : null;
    }
    /**
     * This method is responsible for validating the values passed to the setParcelStatus method
     * This method is willingly generated in order to preserve the one-line inline validation within the setParcelStatus method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateParcelStatusForArrayConstraintsFromSetParcelStatus(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfParcelStatusParcelStatusItem) {
            // validation for constraint: itemType
            if (!$arrayOfParcelStatusParcelStatusItem instanceof \StructType\ParcelStatus) {
                $invalidValues[] = is_object($arrayOfParcelStatusParcelStatusItem) ? get_class($arrayOfParcelStatusParcelStatusItem) : sprintf('%s(%s)', gettype($arrayOfParcelStatusParcelStatusItem), var_export($arrayOfParcelStatusParcelStatusItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ParcelStatus property can only contain items of type \StructType\ParcelStatus, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ParcelStatus value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ParcelStatus[] $parcelStatus
     * @return \ArrayType\ArrayOfParcelStatus
     */
    public function setParcelStatus(array $parcelStatus = array())
    {
        // validation for constraint: array
        if ('' !== ($parcelStatusArrayErrorMessage = self::validateParcelStatusForArrayConstraintsFromSetParcelStatus($parcelStatus))) {
            throw new \InvalidArgumentException($parcelStatusArrayErrorMessage, __LINE__);
        }
        if (is_null($parcelStatus) || (is_array($parcelStatus) && empty($parcelStatus))) {
            unset($this->ParcelStatus);
        } else {
            $this->ParcelStatus = $parcelStatus;
        }
        return $this;
    }
    /**
     * Add item to ParcelStatus value
     * @throws \InvalidArgumentException
     * @param \StructType\ParcelStatus $item
     * @return \ArrayType\ArrayOfParcelStatus
     */
    public function addToParcelStatus(\StructType\ParcelStatus $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ParcelStatus) {
            throw new \InvalidArgumentException(sprintf('The ParcelStatus property can only contain items of type \StructType\ParcelStatus, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ParcelStatus[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ParcelStatus|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ParcelStatus|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ParcelStatus|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ParcelStatus|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ParcelStatus|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ParcelStatus
     */
    public function getAttributeName()
    {
        return 'ParcelStatus';
    }
}
