<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPrintDataInfo ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfPrintDataInfo
 * @subpackage Arrays
 */
class ArrayOfPrintDataInfo extends AbstractStructArrayBase
{
    /**
     * The PrintDataInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PrintDataInfo[]
     */
    public $PrintDataInfo;
    /**
     * Constructor method for ArrayOfPrintDataInfo
     * @uses ArrayOfPrintDataInfo::setPrintDataInfo()
     * @param \StructType\PrintDataInfo[] $printDataInfo
     */
    public function __construct(array $printDataInfo = array())
    {
        $this
            ->setPrintDataInfo($printDataInfo);
    }
    /**
     * Get PrintDataInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PrintDataInfo[]|null
     */
    public function getPrintDataInfo()
    {
        return isset($this->PrintDataInfo) ? $this->PrintDataInfo : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPrintDataInfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPrintDataInfo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePrintDataInfoForArrayConstraintsFromSetPrintDataInfo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPrintDataInfoPrintDataInfoItem) {
            // validation for constraint: itemType
            if (!$arrayOfPrintDataInfoPrintDataInfoItem instanceof \StructType\PrintDataInfo) {
                $invalidValues[] = is_object($arrayOfPrintDataInfoPrintDataInfoItem) ? get_class($arrayOfPrintDataInfoPrintDataInfoItem) : sprintf('%s(%s)', gettype($arrayOfPrintDataInfoPrintDataInfoItem), var_export($arrayOfPrintDataInfoPrintDataInfoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PrintDataInfo property can only contain items of type \StructType\PrintDataInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PrintDataInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PrintDataInfo[] $printDataInfo
     * @return \ArrayType\ArrayOfPrintDataInfo
     */
    public function setPrintDataInfo(array $printDataInfo = array())
    {
        // validation for constraint: array
        if ('' !== ($printDataInfoArrayErrorMessage = self::validatePrintDataInfoForArrayConstraintsFromSetPrintDataInfo($printDataInfo))) {
            throw new \InvalidArgumentException($printDataInfoArrayErrorMessage, __LINE__);
        }
        if (is_null($printDataInfo) || (is_array($printDataInfo) && empty($printDataInfo))) {
            unset($this->PrintDataInfo);
        } else {
            $this->PrintDataInfo = $printDataInfo;
        }
        return $this;
    }
    /**
     * Add item to PrintDataInfo value
     * @throws \InvalidArgumentException
     * @param \StructType\PrintDataInfo $item
     * @return \ArrayType\ArrayOfPrintDataInfo
     */
    public function addToPrintDataInfo(\StructType\PrintDataInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PrintDataInfo) {
            throw new \InvalidArgumentException(sprintf('The PrintDataInfo property can only contain items of type \StructType\PrintDataInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PrintDataInfo[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PrintDataInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PrintDataInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PrintDataInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PrintDataInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PrintDataInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PrintDataInfo
     */
    public function getAttributeName()
    {
        return 'PrintDataInfo';
    }
}
