<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPrintLabelsInfo ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfPrintLabelsInfo
 * @subpackage Arrays
 */
class ArrayOfPrintLabelsInfo extends AbstractStructArrayBase
{
    /**
     * The PrintLabelsInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PrintLabelsInfo[]
     */
    public $PrintLabelsInfo;
    /**
     * Constructor method for ArrayOfPrintLabelsInfo
     * @uses ArrayOfPrintLabelsInfo::setPrintLabelsInfo()
     * @param \StructType\PrintLabelsInfo[] $printLabelsInfo
     */
    public function __construct(array $printLabelsInfo = array())
    {
        $this
            ->setPrintLabelsInfo($printLabelsInfo);
    }
    /**
     * Get PrintLabelsInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PrintLabelsInfo[]|null
     */
    public function getPrintLabelsInfo()
    {
        return isset($this->PrintLabelsInfo) ? $this->PrintLabelsInfo : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPrintLabelsInfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPrintLabelsInfo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePrintLabelsInfoForArrayConstraintsFromSetPrintLabelsInfo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPrintLabelsInfoPrintLabelsInfoItem) {
            // validation for constraint: itemType
            if (!$arrayOfPrintLabelsInfoPrintLabelsInfoItem instanceof \StructType\PrintLabelsInfo) {
                $invalidValues[] = is_object($arrayOfPrintLabelsInfoPrintLabelsInfoItem) ? get_class($arrayOfPrintLabelsInfoPrintLabelsInfoItem) : sprintf('%s(%s)', gettype($arrayOfPrintLabelsInfoPrintLabelsInfoItem), var_export($arrayOfPrintLabelsInfoPrintLabelsInfoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PrintLabelsInfo property can only contain items of type \StructType\PrintLabelsInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PrintLabelsInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PrintLabelsInfo[] $printLabelsInfo
     * @return \ArrayType\ArrayOfPrintLabelsInfo
     */
    public function setPrintLabelsInfo(array $printLabelsInfo = array())
    {
        // validation for constraint: array
        if ('' !== ($printLabelsInfoArrayErrorMessage = self::validatePrintLabelsInfoForArrayConstraintsFromSetPrintLabelsInfo($printLabelsInfo))) {
            throw new \InvalidArgumentException($printLabelsInfoArrayErrorMessage, __LINE__);
        }
        if (is_null($printLabelsInfo) || (is_array($printLabelsInfo) && empty($printLabelsInfo))) {
            unset($this->PrintLabelsInfo);
        } else {
            $this->PrintLabelsInfo = $printLabelsInfo;
        }
        return $this;
    }
    /**
     * Add item to PrintLabelsInfo value
     * @throws \InvalidArgumentException
     * @param \StructType\PrintLabelsInfo $item
     * @return \ArrayType\ArrayOfPrintLabelsInfo
     */
    public function addToPrintLabelsInfo(\StructType\PrintLabelsInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PrintLabelsInfo) {
            throw new \InvalidArgumentException(sprintf('The PrintLabelsInfo property can only contain items of type \StructType\PrintLabelsInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PrintLabelsInfo[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PrintLabelsInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PrintLabelsInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PrintLabelsInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PrintLabelsInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PrintLabelsInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PrintLabelsInfo
     */
    public function getAttributeName()
    {
        return 'PrintLabelsInfo';
    }
}
