<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSuccessfullyDeleted ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfSuccessfullyDeleted
 * @subpackage Arrays
 */
class ArrayOfSuccessfullyDeleted extends AbstractStructArrayBase
{
    /**
     * The SuccessfullyDeleted
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SuccessfullyDeleted[]
     */
    public $SuccessfullyDeleted;
    /**
     * Constructor method for ArrayOfSuccessfullyDeleted
     * @uses ArrayOfSuccessfullyDeleted::setSuccessfullyDeleted()
     * @param \StructType\SuccessfullyDeleted[] $successfullyDeleted
     */
    public function __construct(array $successfullyDeleted = array())
    {
        $this
            ->setSuccessfullyDeleted($successfullyDeleted);
    }
    /**
     * Get SuccessfullyDeleted value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SuccessfullyDeleted[]|null
     */
    public function getSuccessfullyDeleted()
    {
        return isset($this->SuccessfullyDeleted) ? $this->SuccessfullyDeleted : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSuccessfullyDeleted method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSuccessfullyDeleted method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSuccessfullyDeletedForArrayConstraintsFromSetSuccessfullyDeleted(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSuccessfullyDeletedSuccessfullyDeletedItem) {
            // validation for constraint: itemType
            if (!$arrayOfSuccessfullyDeletedSuccessfullyDeletedItem instanceof \StructType\SuccessfullyDeleted) {
                $invalidValues[] = is_object($arrayOfSuccessfullyDeletedSuccessfullyDeletedItem) ? get_class($arrayOfSuccessfullyDeletedSuccessfullyDeletedItem) : sprintf('%s(%s)', gettype($arrayOfSuccessfullyDeletedSuccessfullyDeletedItem), var_export($arrayOfSuccessfullyDeletedSuccessfullyDeletedItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SuccessfullyDeleted property can only contain items of type \StructType\SuccessfullyDeleted, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SuccessfullyDeleted value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SuccessfullyDeleted[] $successfullyDeleted
     * @return \ArrayType\ArrayOfSuccessfullyDeleted
     */
    public function setSuccessfullyDeleted(array $successfullyDeleted = array())
    {
        // validation for constraint: array
        if ('' !== ($successfullyDeletedArrayErrorMessage = self::validateSuccessfullyDeletedForArrayConstraintsFromSetSuccessfullyDeleted($successfullyDeleted))) {
            throw new \InvalidArgumentException($successfullyDeletedArrayErrorMessage, __LINE__);
        }
        if (is_null($successfullyDeleted) || (is_array($successfullyDeleted) && empty($successfullyDeleted))) {
            unset($this->SuccessfullyDeleted);
        } else {
            $this->SuccessfullyDeleted = $successfullyDeleted;
        }
        return $this;
    }
    /**
     * Add item to SuccessfullyDeleted value
     * @throws \InvalidArgumentException
     * @param \StructType\SuccessfullyDeleted $item
     * @return \ArrayType\ArrayOfSuccessfullyDeleted
     */
    public function addToSuccessfullyDeleted(\StructType\SuccessfullyDeleted $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SuccessfullyDeleted) {
            throw new \InvalidArgumentException(sprintf('The SuccessfullyDeleted property can only contain items of type \StructType\SuccessfullyDeleted, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SuccessfullyDeleted[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SuccessfullyDeleted|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SuccessfullyDeleted|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SuccessfullyDeleted|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SuccessfullyDeleted|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SuccessfullyDeleted|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SuccessfullyDeleted
     */
    public function getAttributeName()
    {
        return 'SuccessfullyDeleted';
    }
}
