<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetParcelListRequest StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:GetParcelListRequest
 * @subpackage Structs
 */
class GetParcelListRequest extends APIRequestBase
{
    /**
     * The PickupDateFrom
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $PickupDateFrom;
    /**
     * The PickupDateTo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $PickupDateTo;
    /**
     * The PrintDateFrom
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $PrintDateFrom;
    /**
     * The PrintDateTo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $PrintDateTo;
    /**
     * Constructor method for GetParcelListRequest
     * @uses GetParcelListRequest::setPickupDateFrom()
     * @uses GetParcelListRequest::setPickupDateTo()
     * @uses GetParcelListRequest::setPrintDateFrom()
     * @uses GetParcelListRequest::setPrintDateTo()
     * @param string $pickupDateFrom
     * @param string $pickupDateTo
     * @param string $printDateFrom
     * @param string $printDateTo
     */
    public function __construct($pickupDateFrom = null, $pickupDateTo = null, $printDateFrom = null, $printDateTo = null)
    {
        $this
            ->setPickupDateFrom($pickupDateFrom)
            ->setPickupDateTo($pickupDateTo)
            ->setPrintDateFrom($printDateFrom)
            ->setPrintDateTo($printDateTo);
    }
    /**
     * Get PickupDateFrom value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPickupDateFrom()
    {
        return isset($this->PickupDateFrom) ? $this->PickupDateFrom : null;
    }
    /**
     * Set PickupDateFrom value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $pickupDateFrom
     * @return \StructType\GetParcelListRequest
     */
    public function setPickupDateFrom($pickupDateFrom = null)
    {
        // validation for constraint: string
        if (!is_null($pickupDateFrom) && !is_string($pickupDateFrom)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($pickupDateFrom, true), gettype($pickupDateFrom)), __LINE__);
        }
        if (is_null($pickupDateFrom) || (is_array($pickupDateFrom) && empty($pickupDateFrom))) {
            unset($this->PickupDateFrom);
        } else {
            $this->PickupDateFrom = $pickupDateFrom;
        }
        return $this;
    }
    /**
     * Get PickupDateTo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPickupDateTo()
    {
        return isset($this->PickupDateTo) ? $this->PickupDateTo : null;
    }
    /**
     * Set PickupDateTo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $pickupDateTo
     * @return \StructType\GetParcelListRequest
     */
    public function setPickupDateTo($pickupDateTo = null)
    {
        // validation for constraint: string
        if (!is_null($pickupDateTo) && !is_string($pickupDateTo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($pickupDateTo, true), gettype($pickupDateTo)), __LINE__);
        }
        if (is_null($pickupDateTo) || (is_array($pickupDateTo) && empty($pickupDateTo))) {
            unset($this->PickupDateTo);
        } else {
            $this->PickupDateTo = $pickupDateTo;
        }
        return $this;
    }
    /**
     * Get PrintDateFrom value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPrintDateFrom()
    {
        return isset($this->PrintDateFrom) ? $this->PrintDateFrom : null;
    }
    /**
     * Set PrintDateFrom value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $printDateFrom
     * @return \StructType\GetParcelListRequest
     */
    public function setPrintDateFrom($printDateFrom = null)
    {
        // validation for constraint: string
        if (!is_null($printDateFrom) && !is_string($printDateFrom)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($printDateFrom, true), gettype($printDateFrom)), __LINE__);
        }
        if (is_null($printDateFrom) || (is_array($printDateFrom) && empty($printDateFrom))) {
            unset($this->PrintDateFrom);
        } else {
            $this->PrintDateFrom = $printDateFrom;
        }
        return $this;
    }
    /**
     * Get PrintDateTo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPrintDateTo()
    {
        return isset($this->PrintDateTo) ? $this->PrintDateTo : null;
    }
    /**
     * Set PrintDateTo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $printDateTo
     * @return \StructType\GetParcelListRequest
     */
    public function setPrintDateTo($printDateTo = null)
    {
        // validation for constraint: string
        if (!is_null($printDateTo) && !is_string($printDateTo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($printDateTo, true), gettype($printDateTo)), __LINE__);
        }
        if (is_null($printDateTo) || (is_array($printDateTo) && empty($printDateTo))) {
            unset($this->PrintDateTo);
        } else {
            $this->PrintDateTo = $printDateTo;
        }
        return $this;
    }
}
