<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetPrintedLabelsResponse StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:GetPrintedLabelsResponse
 * @subpackage Structs
 */
class GetPrintedLabelsResponse extends AbstractStructBase
{
    /**
     * The GetPrintedLabelsResult
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\GetPrintedLabelsResponse
     */
    public $GetPrintedLabelsResult;
    /**
     * The GetPrintedLabelsErrorList
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfErrorInfo
     */
    public $GetPrintedLabelsErrorList;
    /**
     * The Labels
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Labels;
    /**
     * The PrintDataInfoList
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfPrintDataInfo
     */
    public $PrintDataInfoList;
    /**
     * Constructor method for GetPrintedLabelsResponse
     * @uses GetPrintedLabelsResponse::setGetPrintedLabelsResult()
     * @uses GetPrintedLabelsResponse::setGetPrintedLabelsErrorList()
     * @uses GetPrintedLabelsResponse::setLabels()
     * @uses GetPrintedLabelsResponse::setPrintDataInfoList()
     * @param \StructType\GetPrintedLabelsResponse $getPrintedLabelsResult
     * @param \ArrayType\ArrayOfErrorInfo $getPrintedLabelsErrorList
     * @param string $labels
     * @param \ArrayType\ArrayOfPrintDataInfo $printDataInfoList
     */
    public function __construct(\StructType\GetPrintedLabelsResponse $getPrintedLabelsResult = null, \ArrayType\ArrayOfErrorInfo $getPrintedLabelsErrorList = null, $labels = null, \ArrayType\ArrayOfPrintDataInfo $printDataInfoList = null)
    {
        $this
            ->setGetPrintedLabelsResult($getPrintedLabelsResult)
            ->setGetPrintedLabelsErrorList($getPrintedLabelsErrorList)
            ->setLabels($labels)
            ->setPrintDataInfoList($printDataInfoList);
    }
    /**
     * Get GetPrintedLabelsResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\GetPrintedLabelsResponse|null
     */
    public function getGetPrintedLabelsResult()
    {
        return isset($this->GetPrintedLabelsResult) ? $this->GetPrintedLabelsResult : null;
    }
    /**
     * Set GetPrintedLabelsResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\GetPrintedLabelsResponse $getPrintedLabelsResult
     * @return \StructType\GetPrintedLabelsResponse
     */
    public function setGetPrintedLabelsResult(\StructType\GetPrintedLabelsResponse $getPrintedLabelsResult = null)
    {
        if (is_null($getPrintedLabelsResult) || (is_array($getPrintedLabelsResult) && empty($getPrintedLabelsResult))) {
            unset($this->GetPrintedLabelsResult);
        } else {
            $this->GetPrintedLabelsResult = $getPrintedLabelsResult;
        }
        return $this;
    }
    /**
     * Get GetPrintedLabelsErrorList value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfErrorInfo|null
     */
    public function getGetPrintedLabelsErrorList()
    {
        return isset($this->GetPrintedLabelsErrorList) ? $this->GetPrintedLabelsErrorList : null;
    }
    /**
     * Set GetPrintedLabelsErrorList value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfErrorInfo $getPrintedLabelsErrorList
     * @return \StructType\GetPrintedLabelsResponse
     */
    public function setGetPrintedLabelsErrorList(\ArrayType\ArrayOfErrorInfo $getPrintedLabelsErrorList = null)
    {
        if (is_null($getPrintedLabelsErrorList) || (is_array($getPrintedLabelsErrorList) && empty($getPrintedLabelsErrorList))) {
            unset($this->GetPrintedLabelsErrorList);
        } else {
            $this->GetPrintedLabelsErrorList = $getPrintedLabelsErrorList;
        }
        return $this;
    }
    /**
     * Get Labels value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLabels()
    {
        return isset($this->Labels) ? $this->Labels : null;
    }
    /**
     * Set Labels value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $labels
     * @return \StructType\GetPrintedLabelsResponse
     */
    public function setLabels($labels = null)
    {
        // validation for constraint: string
        if (!is_null($labels) && !is_string($labels)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($labels, true), gettype($labels)), __LINE__);
        }
        if (is_null($labels) || (is_array($labels) && empty($labels))) {
            unset($this->Labels);
        } else {
            $this->Labels = $labels;
        }
        return $this;
    }
    /**
     * Get PrintDataInfoList value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfPrintDataInfo|null
     */
    public function getPrintDataInfoList()
    {
        return isset($this->PrintDataInfoList) ? $this->PrintDataInfoList : null;
    }
    /**
     * Set PrintDataInfoList value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfPrintDataInfo $printDataInfoList
     * @return \StructType\GetPrintedLabelsResponse
     */
    public function setPrintDataInfoList(\ArrayType\ArrayOfPrintDataInfo $printDataInfoList = null)
    {
        if (is_null($printDataInfoList) || (is_array($printDataInfoList) && empty($printDataInfoList))) {
            unset($this->PrintDataInfoList);
        } else {
            $this->PrintDataInfoList = $printDataInfoList;
        }
        return $this;
    }
}
