<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PrintLabelsResponse StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:PrintLabelsResponse
 * @subpackage Structs
 */
class PrintLabelsResponse extends AbstractStructBase
{
    /**
     * The PrintLabelsResult
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PrintLabelsResponse
     */
    public $PrintLabelsResult;
    /**
     * The Labels
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Labels;
    /**
     * The PrintLabelsErrorList
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfErrorInfo
     */
    public $PrintLabelsErrorList;
    /**
     * The PrintLabelsInfoList
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfPrintLabelsInfo
     */
    public $PrintLabelsInfoList;
    /**
     * Constructor method for PrintLabelsResponse
     * @uses PrintLabelsResponse::setPrintLabelsResult()
     * @uses PrintLabelsResponse::setLabels()
     * @uses PrintLabelsResponse::setPrintLabelsErrorList()
     * @uses PrintLabelsResponse::setPrintLabelsInfoList()
     * @param \StructType\PrintLabelsResponse $printLabelsResult
     * @param string $labels
     * @param \ArrayType\ArrayOfErrorInfo $printLabelsErrorList
     * @param \ArrayType\ArrayOfPrintLabelsInfo $printLabelsInfoList
     */
    public function __construct(\StructType\PrintLabelsResponse $printLabelsResult = null, $labels = null, \ArrayType\ArrayOfErrorInfo $printLabelsErrorList = null, \ArrayType\ArrayOfPrintLabelsInfo $printLabelsInfoList = null)
    {
        $this
            ->setPrintLabelsResult($printLabelsResult)
            ->setLabels($labels)
            ->setPrintLabelsErrorList($printLabelsErrorList)
            ->setPrintLabelsInfoList($printLabelsInfoList);
    }
    /**
     * Get PrintLabelsResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PrintLabelsResponse|null
     */
    public function getPrintLabelsResult()
    {
        return isset($this->PrintLabelsResult) ? $this->PrintLabelsResult : null;
    }
    /**
     * Set PrintLabelsResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\PrintLabelsResponse $printLabelsResult
     * @return \StructType\PrintLabelsResponse
     */
    public function setPrintLabelsResult(\StructType\PrintLabelsResponse $printLabelsResult = null)
    {
        if (is_null($printLabelsResult) || (is_array($printLabelsResult) && empty($printLabelsResult))) {
            unset($this->PrintLabelsResult);
        } else {
            $this->PrintLabelsResult = $printLabelsResult;
        }
        return $this;
    }
    /**
     * Get Labels value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLabels()
    {
        return isset($this->Labels) ? $this->Labels : null;
    }
    /**
     * Set Labels value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $labels
     * @return \StructType\PrintLabelsResponse
     */
    public function setLabels($labels = null)
    {
        // validation for constraint: string
        if (!is_null($labels) && !is_string($labels)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($labels, true), gettype($labels)), __LINE__);
        }
        if (is_null($labels) || (is_array($labels) && empty($labels))) {
            unset($this->Labels);
        } else {
            $this->Labels = $labels;
        }
        return $this;
    }
    /**
     * Get PrintLabelsErrorList value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfErrorInfo|null
     */
    public function getPrintLabelsErrorList()
    {
        return isset($this->PrintLabelsErrorList) ? $this->PrintLabelsErrorList : null;
    }
    /**
     * Set PrintLabelsErrorList value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfErrorInfo $printLabelsErrorList
     * @return \StructType\PrintLabelsResponse
     */
    public function setPrintLabelsErrorList(\ArrayType\ArrayOfErrorInfo $printLabelsErrorList = null)
    {
        if (is_null($printLabelsErrorList) || (is_array($printLabelsErrorList) && empty($printLabelsErrorList))) {
            unset($this->PrintLabelsErrorList);
        } else {
            $this->PrintLabelsErrorList = $printLabelsErrorList;
        }
        return $this;
    }
    /**
     * Get PrintLabelsInfoList value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfPrintLabelsInfo|null
     */
    public function getPrintLabelsInfoList()
    {
        return isset($this->PrintLabelsInfoList) ? $this->PrintLabelsInfoList : null;
    }
    /**
     * Set PrintLabelsInfoList value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfPrintLabelsInfo $printLabelsInfoList
     * @return \StructType\PrintLabelsResponse
     */
    public function setPrintLabelsInfoList(\ArrayType\ArrayOfPrintLabelsInfo $printLabelsInfoList = null)
    {
        if (is_null($printLabelsInfoList) || (is_array($printLabelsInfoList) && empty($printLabelsInfoList))) {
            unset($this->PrintLabelsInfoList);
        } else {
            $this->PrintLabelsInfoList = $printLabelsInfoList;
        }
        return $this;
    }
}
